// -*-c++-*-

/*
 * $Id: ParticleAction.cpp,v 1.1.1.1 2001/12/29 18:28:07 uli Exp $
 *
 * Particle Action
 */

#include "ParticleAction.h"
#include "ParticleSystem.h"


// Global GravityAction
GravityAction s_GravityAction;


/**********************************************************************
 *
 * Particle Action
 *
 **********************************************************************/

// Apply action to all 'alive' particles
void ParticleAction::apply(vector<Particle*>& particle,
                           unsigned int first, unsigned int last)
{
    for (unsigned int i = first; i <= last; i++) {
        Particle* p = particle[i];
        if (p && p->_lifeRemain > 0.0f) {
            applyForce(p);
        }
    }
}

/*
 * Gravity action
 */
void GravityAction::applyForce(Particle* particle)
{
    const osg::Vec3 accel(0.0f, 0.0f, -9.81f);
    particle->_force += (accel * particle->getMass());
}
